﻿using System;
using System.Collections.ObjectModel;
using System.ServiceModel;
using WpfSmartConnect.Properties;

namespace WpfSmartConnect
{
    class ユーザー管理一覧
    {
        // バインディングの指定先プロパティ
        public ObservableCollection<ユーザー管理> d_ユーザー管理 { get; }
        public ObservableCollection<ユーザー管理> d_ユーザー管理_削除済み { get; }
        public ObservableCollection<string> d_属性 { get; }

        private ServiceReference2.SCS_ServiceClient _client;

        // コンストラクタ(データ入力)
        public ユーザー管理一覧()
        {
            try
            {
                var settings = Settings.Default;

                //SCSへ接続する
                _client = new ServiceReference2.SCS_ServiceClient();
                _client.Endpoint.Address = new EndpointAddress("http://" + settings.SvrAddr + ":55963/CTI_SmartConnectService/SCS_Service/");

                var scs = _client.ユーザー管理(null, null);
                d_ユーザー管理 = Newtonsoft.Json.JsonConvert.DeserializeObject<ObservableCollection<ユーザー管理>>(scs);

                //属性
                d_属性 = new ObservableCollection<string>();
                d_属性.Add("管理者");
                d_属性.Add("一般");
                d_属性.Add("ゲスト");
                d_属性.Add("その他");

                //削除済み用
                d_ユーザー管理_削除済み = new ObservableCollection<ユーザー管理>();
            }
            catch (FaultException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信でエラーが発生しました。", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (TimeoutException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信がタイムアウトしました。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (CommunicationException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信が確立出来ません。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (Exception ex)
            {
                Logs_MessageBox.Show(ex.Message, "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
        }
    }
}
