﻿using System;
using System.Collections.ObjectModel;
using System.ServiceModel;
using WpfSmartConnect.Properties;

namespace WpfSmartConnect
{
    class 収容回線一覧
    {
        // バインディングの指定先プロパティ
        public ObservableCollection<収容回線> d_収容回線 { get; }
        public ObservableCollection<収容回線> d_収容回線_削除済み { get; }
        public ObservableCollection<string> d_種別 { get; }

        private ServiceReference2.SCS_ServiceClient _client;

        // コンストラクタ(データ入力)
        public 収容回線一覧()
        {
            try
            {
                var settings = Settings.Default;

                //SCSへ接続する
                _client = new ServiceReference2.SCS_ServiceClient();
                _client.Endpoint.Address = new EndpointAddress("http://" + settings.SvrAddr + ":55963/CTI_SmartConnectService/SCS_Service/");

                var scs = _client.収容回線(null, null);
                d_収容回線 = Newtonsoft.Json.JsonConvert.DeserializeObject<ObservableCollection<収容回線>>(scs);

                //種別コンボボックス
                d_種別 = new ObservableCollection<string>();
                d_種別.Add("電話");
                d_種別.Add("FAX");
                d_種別.Add("IP電話");
                d_種別.Add("IP-FAX");
                d_種別.Add("IP-PBX");

                //削除済み用
                d_収容回線_削除済み = new ObservableCollection<収容回線>();
            }
            catch (FaultException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信でエラーが発生しました。", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (TimeoutException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信がタイムアウトしました。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (CommunicationException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信が確立出来ません。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (Exception ex)
            {
                Logs_MessageBox.Show(ex.Message, "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
        }
    }
}
