﻿using System;
using System.Collections.ObjectModel;
using System.ServiceModel;
using WpfSmartConnect.Properties;

namespace WpfSmartConnect
{
    class 通知先メールアドレス一覧
    {
        // バインディングの指定先プロパティ
        public ObservableCollection<通知先メールアドレス> d_通知先メールアドレス { get; }
        public ObservableCollection<通知先メールアドレス> d_通知先メールアドレス_削除済み { get; }
        public ObservableCollection<string> d_文字コード { get; }

        private ServiceReference2.SCS_ServiceClient _client;

        // コンストラクタ(データ入力)
        public 通知先メールアドレス一覧()
        {
            try
            {
                var settings = Settings.Default;

                //SCSへ接続する
                _client = new ServiceReference2.SCS_ServiceClient();
                _client.Endpoint.Address = new EndpointAddress("http://" + settings.SvrAddr + ":55963/CTI_SmartConnectService/SCS_Service/");

                var scs = _client.通知先メールアドレス(null, null);
                d_通知先メールアドレス = Newtonsoft.Json.JsonConvert.DeserializeObject<ObservableCollection<通知先メールアドレス>>(scs);

                //文字コードコンボボックス
                d_文字コード = new ObservableCollection<string>();
                d_文字コード.Add("JISコード");
                d_文字コード.Add("UTF-8");

                //削除済み用
                d_通知先メールアドレス_削除済み = new ObservableCollection<通知先メールアドレス>();
            }
            catch (FaultException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信でエラーが発生しました。", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (TimeoutException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信がタイムアウトしました。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (CommunicationException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信が確立出来ません。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (Exception ex)
            {
                Logs_MessageBox.Show(ex.Message, "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
        }
    }
}
